import os
import re
import time


global elementDataDict
global molecularMassCache


def calculateMolecularMass(molecularFormula):
    
    if molecularMassCache.has_key(molecularFormula):
        return molecularMassCache[molecularFormula]
    else:
        global elementDataDict
    
        componentElements = re.findall("[A-Z]{1}[0-9]*[a-z]{0,1}[0-9]*", molecularFormula)
        molecMass =  0
        elementCountComp = 1
    
        for elementSymbol in componentElements:
            result = re.search("[A-z]*", elementSymbol)
        
            if(result):
                elementSymbolComp = result.group(0)
    
            result = re.search("[0-9]+", elementSymbol)
        
            if(result):
                elementCountComp = result.group(0)
        
            molecMass =  molecMass + float(elementDataDict[elementSymbolComp]) * int(elementCountComp)
            elementCountComp = 1
        
        molecularMassCache[molecularFormula] = molecMass

        return molecMass
    
    
    
def calculateTime(molecularFormula):
    startTime = time.clock()
    calculateMolecularMass(molecularFormula)
    elapsedTime = (time.clock() - startTime)
    print '{0:8s} {1:8s} {2:6s} {3:17s} {4:8f} {5:7s}'.format(molecularFormula + ":", 
                                                              str(calculateMolecularMass(molecularFormula)), 
                                                              "amu","Calculation Time:", elapsedTime, "seconds")


elementDataDict = {}
molecularMassCache = {}

filename = os.path.join("data", 'element_data.txt')
fileObj = open(filename, 'r')


#load element data into dictionary
for line in fileObj.readlines():
    line = line.strip()
    (element, amu) = line.split()
    elementDataDict[element] = amu

fileObj.close()

formula1 = "H2O"       #Water
formula2 = "P4S3"      #Tetraphosphorus trisulfide 
formula3 = "NH4NO3"    #Ammonium nitrate 


calculateTime(formula1)
calculateTime(formula2)
calculateTime(formula3)
calculateTime(formula3)
    
